#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF

DO EXAMPLE

return


PROC appsys ; RETURN


PROCEDURE EXAMPLE
LOCAL aPos:={0,0},aSize:={0,0}
LOCAL GetOptions ,GetList:={}
LOCAL oButton,oColumn

PRIVATE oDialog,oDarea
PRIVATE oBrowse,lStatus


aSize:={ 900,600 }
aPos[1]:=10
aPos[2]:=100

oDialog := XbpDialog():New(,, aPos, aSize )
oDialog:Title := "EXAMPLE"
oDialog:minSize:=aSize
oDialog:maxSize:=aSize
oDialog:sysMenu:=.F.
oDialog:hideButton:=.F.
oDialog:border := XBPDLG_THINBORDER
oDialog:Create()

// trick to hide min,max button
oDialog:maxButton:=.F.
oDialog:minButton:=.F.
oDialog:configure()

SetAppFocus(oDialog)
oDarea:=oDialog:drawingArea

USE ("TEST2.DBF") ALIAS DBTEST NEW
dbgotop()

@  2,4 DCBROWSE oBrowse SIZE 120,18 ID "BROWSE" ;
                CURSORMODE XBPBRW_CURSOR_ROW ALIAS "DBTEST" ;
                PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },      ;   /// Header FG Color
                            { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND }, ;   /// Header BG Color
                            { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },     ;   /// Footer FG Color
                            { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },   ;   /// Footer BG Color
                            { XBP_PP_COL_DA_CELLHEIGHT, 20 }}            ;   /// Cell Height
                NOSIZECOLS

    DCBROWSECOL FIELD DBTEST->RGSOC Header "Ragione Sociale"   WIDTH 15 PARENT oBrowse OBJECT oColumn
    DCBROWSECOL FIELD DBTEST->RGAGG Header "Rag.Agg."          WIDTH 10 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->PROVI Header "Mnemonico"         WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->PTIVA Header "Part.IVA"          WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->CFISC Header "Cod.Fiscale"       WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->CITTA Header "Citta"             WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->PROVI Header "Prov."             WIDTH  5 PARENT oBrowse


@ 22,5 DCPUSHBUTTON CAPTION "INSERT NEW RECORD [F5]"  OBJECT oButton ;
                    ACTION {||oButton:disable() ,NEW_ROW(GetList) , oButton:enable()} SIZE 30,2 ;
                    ACCELKEY xbeK_F5 PARENT oWindow TABSTOP


DCGETOPTIONS NOBUSY CONFIRM NOMINBUTTON NOMAXBUTTON NOTASKLIST NORESIZE


DCREAD GUI TO lStatus OPTIONS GetOptions PARENT oDarea ; // ENTEREXIT ;
       SETFOCUS "BROWSE"

RETURN



STATIC FUNCTION NEW_ROW
LOCAL GetOptions ,GetList:={}
LOCAL aSize,aPos,nColPos,nRowPos,oColumn,oColumn2,oCell,aRect,nHeadHeight,nRowHeight,nRowWidth
LOCAL nT,nX,nY
LOCAL oDialogNew,oDareaNew

// go to bottom of DB
oBrowse:goBottom()
oBrowse:forceStable()

aSize:=oBrowse:currentSize()
aPos:=oBrowse:currentPos()
nColPos := oBrowse:colPos
nRowPos := oBrowse:rowPos

oColumn := oBrowse:getColumn( 1 ) // #column1
oCell := oColumn:dataArea
aRect := oCell:CellRect( nRowPos )

nHeadHeight:=oColumn:heading:currentSize()[2]

nRowHeight:=aRect[4]-aRect[2]
nRowWidth:=aSize[1]

IF oBrowse:rowPos < oBrowse:rowCount -1
    // dehilite the row cursor bar again - xbase 1.9
    oBrowse:dehilite()
    AEval( oBrowse:aColumns, {|o| o:Redraw() } )
    IF !EOF()
        nRowPos++
    ENDIF

ELSE
    // shift up previous rows
    FOR nT:=2 TO oBrowse:rowPos
        AEval( oBrowse:aColumns, {|o| o:DataArea:setCell( nT-1, o:DataArea:getCell( nT) ) } ) // clear data ROW
    NEXT

    // add virtual empty row
    AEval( oBrowse:aColumns, {|o| o:DataArea:setCell( oBrowse:RowPos, NIL ) } ) // clear data ROW
ENDIF

nY := nRowHeight*(nRowPos) + nHeadHeight
nX := aPos[1]

altd()
oBrowse:disable()

@ nY,nX DCDIALOG oDialogNew NOTITLEBAR SIZE nRowWidth,nRowHeight DRAWINGAREA oDareaNew ;
    BORDER XBPDLG_DLGBORDER PIXEL ;
    COLOR GRA_CLR_DARKBLUE,GRA_CLR_DARKBLUE ;
    NOMAXBUTTON NOMINBUTTON NOTASKLIST NOTITLEBAR NORESIZE ;
    PARENT oDarea


// example of two GETs
cVar1:=SPACE(10)
cVar2:=SPACE(15)
@ 0,0  DCGET cVar1 GETSIZE (oColumn:currentSize()[1]-2) PIXEL  GETID "GET1" PARENT oDareaNew
oColumn2 := oBrowse:getColumn( 2 ) // #column2
@ 0,(oColumn:currentSize()[1]+1) DCGET cVar2 GETSIZE (oColumn2:currentSize()[1]-2) PIXEL  PARENT oDareaNew


DCGETOPTIONS  CONFIRM  NOTITLE NORESIZE FITPAD 0

DCREAD GUI TO lStatus OPTIONS GetOptions  ;
       SETFOCUS "GET1" ENTEREXIT PARENT oDialog


oBrowse:enable()

// Refresh all browse
oBrowse:goBottom()
oBrowse:forceStable()

// hilite the row cursor bar again - xbase 1.9
oBrowse:hilite()
AEval( oBrowse:aColumns, {|o| o:Redraw() } )

RETURN NIL



